# Maintainers

This file lists how the Chef project is maintained. When making changes to the system, this
file tells you who needs to review your patch - you need a simple majority of maintainers
for the relevant subsystems to provide a :+1: on your pull request. Additionally, you need
to not receive a veto from a Lieutenant or the Project Lead.

Check out [How Chef is Maintained](https://github.com/opscode/chef-rfc/blob/master/rfc030-maintenance-policy.md#how-the-project-is-maintained) for details on the process, how to become
a maintainer, lieutenant, or the project lead.

# Project Lead

[Adam Jacob](http://github.com/adamhjk)

# Components

## Chef Core

Handles the core parts of the Chef DSL, base resource and provider
infrastructure, and the Chef applications. Includes anything not covered by
another component.

### Lieutenant

### Maintainers

* [Jon Cowie](http://github.com/jonlives)
* [Phil Dibowitz](https://github.com/jaymzh)
* [Lamont Granquist](http://github.com/lamont-granquist)
* [Tyler Ball](https://github.com/tyler-ball)
* [Daniel DeLeo](https://github.com/danielsdeleo)
* [Claire McQuin](https://github.com/mcquin)
* [Jay Mundrawala](http://github.com/jdmundrawala)
* [Bryan McLellan](http://github.com/btm)
* [Ranjib Dey](http://github.com/ranjib)
* [AJ Christensen](https://github.com/fujin)

## Dev Tools

Chef Zero, Knife, Chef Apply and Chef Shell.

### Lieutenant

### Maintainers

* [Steven Danna](https://github.com/stevendanna/)
* [Joshua Timberman](https://github.com/jtimberman)
* [Lamont Granquist](http://github.com/lamont-granquist)
* [Daniel DeLeo](https://github.com/danielsdeleo)

## Test Tools

### ChefSpec

#### Lieutenant

[Seth Vargo](https://github.com/sethvargo)

#### Maintainers

* [Joshua Timberman](https://github.com/jtimberman)
* [Lamont Granquist](http://github.com/lamont-granquist)
* [Ranjib Dey](http://github.com/ranjib)

## Platform Specific Components

The specific components of Chef related to a given platform - including (but not limited to) resources, providers, and the core DSL.

## Enterprise Linux

### Lieutenant

### Maintainers

* [Jon Cowie](http://github.com/jonlives)
* [Lamont Granquist](http://github.com/lamont-granquist)

## Ubuntu

### Lieutenant

### Maintainers

* [Lamont Granquist](http://github.com/lamont-granquist)
* [Ranjib Dey](http://github.com/ranjib)

## Windows

### Lieutenant

* [Bryan McLellan](http://github.com/btm)

### Maintainers
* [Steven Murawski](http://github.com/smurawski)
* [Jay Mundrawala](http://github.com/jdmundrawala)

## Solaris

### Lieutenant

### Maintainers

* [Lamont Granquist](http://github.com/lamont-granquist)

## AIX

### Lieutenant

### Maintainers

* [Lamont Granquist](http://github.com/lamont-granquist)

## Mac OS X

### Lieutenant

* [Joshua Timberman](https://github.com/jtimberman)

### Maintainers

* [Tyler Ball](https://github.com/tyler-ball)

## FreeBSD

### Lieutenant

* [Aaron Kalin](https://github.com/martinisoft)

### Maintainers

